#include "../include/aprecv-general.h"

int print_spx_packet (unsigned char *packet, int opt_size) {
  static struct spx_pkt_header *spx_header;

  spx_header = (struct spx_pkt_header *)(packet+data_link_size+opt_size);
  
  apsr_output("\n- SPX Header -\n  Connection Control: ");

  if(spx_header->con_control & APSR_SPX_CON_XHD) {
	  apsr_output("XHD ");
  }
  if(spx_header->con_control & APSR_SPX_CON_RES1) {
	  apsr_output("RES1 ");
  }
  if(spx_header->con_control & APSR_SPX_CON_NEG) {
	  apsr_output("NEG ");
  }
  if(spx_header->con_control & APSR_SPX_CON_SPX2) {
	  apsr_output("SPXv2 ");
  }
  if(spx_header->con_control & APSR_SPX_CON_EOM) {
	  apsr_output("EOM ");
  }
  if(spx_header->con_control & APSR_SPX_CON_ATN) {
	  apsr_output("ATN ");
  }
  if(spx_header->con_control & APSR_SPX_CON_ACK) {
	  apsr_output("ACK ");
  }
  if(spx_header->con_control & APSR_SPX_CON_SYS) {
	  apsr_output("SYS ");
  }  
  
  apsr_output("\n  Datastream Type: ");
  
  if(spx_header->datastr_type & APSR_SPX_DAT_EOC) {
	  apsr_output("End-of-Connection");

  }
  if(spx_header->datastr_type & APSR_SPX_DAT_EOCA) {
	  apsr_output("End-of-Connection Acknowledgement");
  }  
  
  apsr_output("\n  Source Con. ID: %u, Dest. Con. ID: %u\n", apsr_ntohs(spx_header->source_id), apsr_ntohs(spx_header->dest_id));
  apsr_output("\n  Seq.: %u, Ack-Seq.: %u\n", apsr_ntohs(spx_header->seq_num), apsr_ntohs(spx_header->ack_num));
  apsr_output("\n  Allocation Number: 0x%04x\n", apsr_ntohs(spx_header->alloc_num));

  if(spx_header->con_control & APSR_SPX_CON_SPX2) {
	  apsr_output("  Negotiate Size: %d\n", 
		 apsr_ntohs(spx_header->ext.spx2.negotiate_size));
	  if(statistic)
                stats.c.spx2++;                    
  }
  else if(statistic) 
       stats.c.spx++; 

  return(RET_SUCCESS);
}
