#include "../include/aprecv-general.h"

void print_statistic(void) {
  apsr_unset_quiet();
  apsr_output("\n\n---------- Statistics ----------");

  #ifdef HAVE_APSRLIB_GET_TIME_FORMATTED
  apsr_output("\n\nStart time:\t%s\n", start_time);
  apsr_output("End time:\t%s\n", apsr_get_time_formatted());
  #endif

  apsr_output("\n--- Packets counted ---");
  apsr_output("\nEthernet II\t%lu(%lu|)", stats.c.ethernetII, 
		  stats.tr.ethernetII);
  apsr_output("\t\t802.3raw\t%lu", stats.c.ethernet8023raw);
  apsr_output("\n802.3\t\t%lu\t\t802.3snap\t%lu", stats.c.ethernet8023, 
		  stats.c.ethernet8023snap);
  apsr_output("\n802.1p/1q\t%lu\t\t802.11\t\t%lu(%lu||)", stats.c.vlan, 
		  stats.c.ieee80211, stats.tr.ieee80211);
  apsr_output("\n802.5token\t%u(%lu||)", stats.c.token_ring, 
		  stats.tr.token_ring);
  apsr_output("\t\tFDDI\t\t%lu(%lu||)", stats.c.fddi, stats.tr.fddi);
  apsr_output("\nARP\t\t%lu(|%lu|)\t\tPrism mon\t%lu", stats.c.arp, 
		  stats.err.arp, stats.c.prism_mon);
  apsr_output("\nCDP\t\t%lu(%lu||)", stats.c.cdp, stats.tr.cdp);
  apsr_output("\t\tCisco HDLC\t%lu", stats.c.chdlc);
  apsr_output("\nCGMP\t\t%lu\t\tBOFL\t\t%lu", stats.c.cgmp, stats.c.bofl);
  apsr_output("\nVTP\t\t%lu", stats.c.vtp);
  apsr_output("\n\n\t\t   * ATM Protocols *\n");  
  apsr_output("ATM CLIP\t%lu(%lu/%lu)", 
		  stats.c.atm_clip_withoutllc+stats.c.atm_clip_llc, 
		  stats.c.atm_clip_withoutllc, stats.c.atm_clip_llc);
  apsr_output("\t\tATM RFC1483\t%lu", stats.c.atm_rfc1483);
  apsr_output("\nSunATM\t\t%lu\t\tLUNI\t\t%lu", stats.c.sunatm, stats.c.luni);
  apsr_output("\n\n\t\t   * PPP Protocols *\n");
  apsr_output("PPP\t\t%lu\n", stats.c.ppp);
  apsr_output("PPPoE\t\t%lu\t\tPPPoE Tags\t%lu\n", stats.c.pppoe, 
		  stats.c.pppoe_tag);
  apsr_output("IPCP\t\t%lu(|%lu|)\t\tIPv6CP\t\t%lu", stats.c.ppp_ipcp, 
		  stats.err.ppp_ipcp, stats.c.ppp_ipv6cp);
  apsr_output("\nIPXCP\t\t%lu\t\tATCP\t\t%lu\n", stats.c.ppp_ipxcp, 
		  stats.c.ppp_atcp);
  apsr_output("PAP\t\t%lu\t\tCHAP\t\t%lu\n", stats.c.ppp_pap, 
		  stats.c.ppp_chap);
  apsr_output("ECP\t\t%lu\t\tLCP\t\t%lu\n", stats.c.ppp_ecp, stats.c.ppp_lcp);
  apsr_output("LQR\t\t%lu\t\tCCP\t\t%lu\n", stats.c.ppp_lqr, stats.c.ppp_ccp);
  apsr_output("EAP\t\t%lu\t\tBCP\t\t%lu\n", stats.c.ppp_eap, stats.c.ppp_bcp);
  apsr_output("Decnet CP\t%lu\t\tOSINLCP\t\t%lu\n", stats.c.ppp_decnetcp, 
		  stats.c.ppp_osinlcp);
  apsr_output("SNACP\t\t%lu\n", stats.c.ppp_snacp);
  apsr_output("\n\n\t\t   * IP Protocols *\n");
  apsr_output("IPv4\t\t%lu(|%lu|%lu)", stats.c.ipv4, stats.err.ipv4, 
		  stats.cr.ipv4);
  apsr_output("\t\tIPv6\t\t%lu\n", stats.c.ipv6);
  apsr_output("IPv6 Routing\t%lu\t\tIPv6 Hop-by-Hop\t%u\n", stats.c.ipv6_rt,
	          stats.c.ipv6_hh);	
  apsr_output("IP Auth.\t%lu\t\tIPComp\t\t%lu", stats.c.ipah, 
		  stats.c.ipcomp);
  apsr_output("\nIP ESP\t\t%lu\t\tSCTP\t\t%lu", stats.c.ipesp,
		  stats.c.sctp);  
  apsr_output("\nICMPv4\t\t%lu(||%lu)", stats.c.icmpv4, stats.cr.icmpv4);
  apsr_output("\t\tICMPv6\t\t%lu", stats.c.icmpv6);
  apsr_output("\nTCP\t\t%lu(|%lu|%lu)", stats.c.tcp, stats.err.tcp, 
		  stats.cr.tcp);
  apsr_output("\t\tUDP\t\t%lu(||%lu)", stats.c.udp, stats.cr.udp);
  apsr_output("\nGREv0\t\t%lu\t\tGREv1\t\t%lu", stats.c.grev0,
		  stats.c.grev1);
  apsr_output("\nIFMP\t\t%lu\t\tIRTP\t\t%lu(||%lu)", stats.c.ifmp,
		  stats.c.irtp, stats.cr.irtp);
  apsr_output("\nCBT\t\t%lu\t\tEtherIP\t\t%lu", stats.c.cbt, stats.c.etherip);
  apsr_output("\nMTP\t\t%lu\t\tPGM\t\t%lu", stats.c.mtp, stats.c.pgm);
  apsr_output("\nRDPv1\t\t%lu\t\tRDPv2\t\t%lu", stats.c.rdpv1, stats.c.rdpv2);
  apsr_output("\nNETBLK\t\t%lu\t\tTMux\t\t%lu", stats.c.netblk, 
		  stats.c.tmux_mini);
  apsr_output("\nSDRP\t\t%lu", stats.c.sdrp);
  apsr_output("\n\n\t\t   * IPX Protocols *\n");
  apsr_output("IPX\t\t%lu\t\tRIP\t\t%lu\n", stats.c.ipx, stats.c.ipxrip);
  apsr_output("SPX\t\t%lu\t\tSPXv2\t\t%lu", stats.c.spx, stats.c.spx2);
  apsr_output("\n\n\t\t   * DEC Protocols *\n");
  apsr_output("Dump/Load\t%lu", stats.c.mopv3_dumpload); 
  apsr_output("\n\n\t\t   * Routing Protocols *\n");
  apsr_output("RIPv1\t\t%lu\t\tRIPv2\t\t%lu\n", stats.c.ripv1, stats.c.ripv2);
  apsr_output("RIPng\t\t%lu\t\tVRRP\t\t%lu\n", stats.c.ripng, stats.c.vrrp);
  apsr_output("OSPFv2\t\t%lu\t\tOSPFv3\t\t%lu\n", stats.c.ospfv2, 
		  stats.c.ospfv3);
  apsr_output("NARP\t\t%lu\t\tEGP\t\t%lu(||%lu)", stats.c.narp, stats.c.egp,
		  stats.cr.egp);
  apsr_output("\nGGP\t\t%lu\t\tIGMPv0\t\t%lu(||%lu)",stats.c.ggp,stats.c.igmpv0,
		  stats.cr.igmpv0);
  apsr_output("\nIGMPv1\t\t%lu(||%lu)\t\tIGMPv2\t\t%lu(||%lu)", stats.c.igmpv1, 
		  stats.cr.igmpv1, stats.c.igmpv2, stats.cr.igmpv2);
  apsr_output("\nIGRP\t\t%lu(||%lu)", stats.c.igrp, stats.cr.igrp);
  apsr_output("\t\tEIGRP\t\t%lu(||%lu)", stats.c.eigrp, stats.cr.eigrp);
  apsr_output("\nPIMv1\t\t%lu(||%lu)", stats.c.pimv1, stats.cr.pimv1);
  apsr_output("\t\tPIMv2\t\t%lu(||%lu)\n", stats.c.pimv2, stats.cr.pimv2);
  apsr_output("BGP\t\t%lu\t\tMPLS\t\t%lu\n", stats.c.bgp, stats.c.mpls);
  apsr_output("RSVP\t\t%lu\t\tMSDP\t\t%u\n", stats.c.rsvp, stats.c.msdp);
  apsr_output("GSMP\t\t%lu\t\tRGMP\t\t%u(||%lu)\n", stats.c.gsmp, stats.c.rgmp, 
		  stats.cr.rgmp);
}

void cap_stats (void) {
  static struct pcap_stat stat;

  if (recv_d != NULL && pcap_file(recv_d) == NULL) {
	  if(fflush(stdout) == EOF) {
          #ifdef APRECV_DEBUG
          apsr_stream_output((FILE *) stderr, "Error: fflush(stdout) %s.\n", 
			  strerror(errno));
          #endif
	  }
	  if(pcap_stats(recv_d, &stat) < 0) {
		  #ifdef APRECV_DEBUG
        	  apsr_stream_output((FILE *) stderr, "%s", 
				  pcap_geterr(recv_d));
	          #endif
             	  exit(EXIT_FAILURE);
          }
          else {	
                  apsr_output("\nReceived %d packets", stat.ps_recv);

                  if(count_bytes) {
			  if(all_counted_bytes > 1024000) 
				  apsr_output("(%lu Mbytes)", all_counted_bytes / 1024000);
			  else if(all_counted_bytes > 1024) 
				  apsr_output("(%lu Kbytes)", all_counted_bytes / 1024);
			  else 
				  apsr_output("(%lu Bytes)", all_counted_bytes);
		  }
				  
		  apsr_output(", %d dropped by kernel.\n", stat.ps_drop);

		  /* 
		   * Currently __OSTYPE_SUNOS (4.x) / __OSTYPE_ULTRIX /
		   * __OSTYPE_DIGITAL / __OSTYPE_TRUE64 and __OSTYPE_IRIX
		   * are not defined in configure.ac - 18.05.03 
		   *
		   * #ifdef __OSTYPE_***** 
		   * apsr_output("Packets dropped by interface %u.\n",
		   *             stat.ps_ifdrop);
		   * #endif
		   * 
		   */
	  } 
  }
}
