#include "../include/apsend-general.h"

#ifdef HAVE_APSRLIB_MODULE_SUPPORT
struct apsr_modules *dl_list = NULL;

int load_module (char *module_name) {
	char *error;					/* Error buffer */
	struct apsr_modules *p;
	struct apsr_apsend_module_info module_info;	/* Module info struct */
	static int mod_cnt;				/* Module counter */

	if(!(p=xcalloc(1, sizeof(struct apsr_modules)))) {
		apsr_stream_output((FILE *) stderr, "Error while allocating memory for new module.\n");
	}

	p->dl_handle = dlopen(module_name, RTLD_NOW);

	if(!p->dl_handle) {
		apsr_stream_output((FILE *) stderr, "%s\n", dlerror());
		exit(EXIT_FAILURE);
	}

	/* Export the functions */
	get_module_info = dlsym(p->dl_handle, "module_info");
	if((error = dlerror()) != NULL) {
		apsr_stream_output((FILE *) stderr, error);
		exit(EXIT_FAILURE);
	}

	p->init = dlsym(p->dl_handle, "module_init");
	if((error = dlerror()) != NULL) {
		apsr_stream_output((FILE *) stderr, error);
		exit(EXIT_FAILURE);
	}

	module_info = get_module_info();
	apsr_output("Module name        : %s\n", module_info.name);
	apsr_output("Module version     : %s\n", module_info.version);
	apsr_output("Module requirements: %s\n", module_info.req);

        /* Module counter */
        mod_cnt++;

        if(verbose)
		apsr_output("Module description: %s\n", module_info.desc);

	apsr_output("\n");

	p->info.name	= module_info.name;
	p->info.version = module_info.version;
	p->info.desc	= module_info.desc;
	p->next		= dl_list;
	dl_list		= p;

	return(RET_SUCCESS);
}
#endif
