struct apsrstack_frame_header {
  unsigned int caplen;
  unsigned int len;
  unsigned char src_mac[APSR_ETHER_ADDR_LEN];
  unsigned char dst_mac[APSR_ETHER_ADDR_LEN];
  unsigned short type;
};

/* ARP header */
struct apsrstack_arp_pkt_header {
  unsigned short arp_hat;
  unsigned short arp_pat;
  unsigned char  arp_hal;
  unsigned char  arp_pal;
  unsigned short arp_oc;
  unsigned char sender_hw_addr[APSR_ETHER_ADDR_LEN];
  unsigned char sender_pr_addr[4];
  unsigned char target_hw_addr[APSR_ETHER_ADDR_LEN];
  unsigned char target_pr_addr[4];
};

/* IPv4 header */
struct apsrstack_ipv4_pkt_header {
  unsigned int ipvhl:8;         /* Version + Header length      */
  unsigned int type_service:8;  /* TOS(Type of Service) field   */
  unsigned short packet_len;    /* Header+Payload length        */
  unsigned short ident;         /* Identification field         */
  unsigned short fragment;      /* Fragment Offset field        */
  unsigned int time_live:8;     /* TTL(Time to Live) field      */
  unsigned int protocol:8;      /* Protocol field               */
  unsigned short sum;           /* Checksum field               */
  unsigned char src_ip[4];      /* Source IP                    */
  unsigned char dst_ip[4];      /* Destination IP               */
};

