/* FDDI address length */
#ifndef APSR_FDDI_ADDR_LEN
  #define APSR_FDDI_ADDR_LEN   6
#endif


/* FDDI frame control bits */
#define APSR_FDDIFC_C		0x80		/* FDDI Class bit */
#define APSR_FDDIFC_L		0x40		/* FDDI Address length bit */
#define APSR_FDDIFC_F		0x30		/* FDDI Frame format bits */
#define APSR_FDDIFC_Z		0x0f		/* FDDI Control bits */

/* FDDI Frame Control values (48-bit only) */
#define APSR_FDDIFC_VOID	0x40		/* FDDI void frame */
#define APSR_FDDIFC_NRT		0x80		/* FDDI non-restricted token */
#define APSR_FDDIFC_RT		0xc0		/* FDDI restricted token */
#define APSR_FDDIFC_SMT_INFO	0x41		/* FDDI SMT Info */
#define APSR_FDDIFC_SMT_NSA	0x4F		/* FDDI SMT Next station adrs */
#define APSR_FDDIFC_MAC_BEACON	0xc2		/* FDDI MAC Beacon frame */
#define APSR_FDDIFC_MAC_CLAIM	0xc3		/* FDDI MAC Claim frame */
#define APSR_FDDIFC_LLC_ASYNC	0x50		/* FDDI async. LLC frame */
#define APSR_FDDIFC_LLC_SYNC	0xd0		/* FDDI sync. LLC frame */
#define APSR_FDDIFC_IMP_ASYNC	0x60		/* FDDI implementor Async. */
#define APSR_FDDIFC_IMP_SYNC	0xe0		/* FDDI implementor Synch. */
#define APSR_FDDIFC_SMT		0x40		/* FDDI SMT frame */
#define APSR_FDDIFC_MAC		0xc0		/* FDDI MAC frame */

#define APSR_FDDIFC_CLFF	0xF0		/* FDDI clff bits */
#define APSR_FDDIFC_ZZZZ	0x0F		/* FDDI Control bits */

