/* IPv4 definitions */
#define APSR_IP_NF		0x0000          /* No fragment flags set  */
#define APSR_IP_RF		0x8000          /* Reserved fragment flag */
#define APSR_IP_DF		0x4000          /* Don't fragment flag	  */
#define APSR_IP_MF		0x2000          /* More fragments flag	  */
#define APSR_IP_OFFMASK		0x1fff          /* Fragmenting bits mask  */

#define APSR_IPV4_VERSION(ipv4_ps_header) (((ipv4_ps_header)->ipvhl & 0xf0)>>4)
#define APSR_IPV4_HEADERLENGTH(ipv4_ps_header) ((ipv4_ps_header)->ipvhl & 0x0f)

#define APSR_IP_TOS_DEFAULT  0x0000
#define APSR_IP_TOS_MIN_COS  0x0001
#define APSR_IP_TOS_MAX_REL  0x0010
#define APSR_IP_TOS_MAX_THR  0x0100
#define APSR_IP_TOS_MIN_DEL  0x1000
#define APSR_IP_TOS_MAX_SEC  0x1111

#define APSR_IP_OPT_EOOL	0	/* End of options list		*/
#define APSR_IP_OPT_NOP		1	/* No operation			*/
#define APSR_IP_OPT_RR		7	/* Record route			*/
#define APSR_IP_OPT_ZSU         10	/* Experimental Measurement	*/
#define APSR_IP_OPT_MTUP	11	/* MTU probe			*/
#define APSR_IP_OPT_MTUR	12	/* MTU reply			*/
#define APSR_IP_OPT_ENCODE	15	/* ???				*/
#define APSR_IP_OPT_TS		68	/* Timestamp			*/
#define APSR_IP_OPT_TR		82	/* Traceroute			*/
#define APSR_IP_OPT_SEC		130	/* Security			*/
#define APSR_IP_OPT_LSR		131	/* Loose source route		*/
#define APSR_IP_OPT_ESEC	133	/* Extended security		*/
#define APSR_IP_OPT_CIPSO	134	/* Commercial security		*/
#define APSR_IP_OPT_SID		136	/* Stream ID			*/
#define APSR_IP_OPT_SSR		137	/* Strict source route 		*/
#define APSR_IP_OPT_VISA	142	/* Experimental access control	*/
#define APSR_IP_OPT_IMITD	144	/* IMI traffic descriptor	*/
#define APSR_IP_OPT_EIP		145	/* Extended internet protocol	*/
#define APSR_IP_OPT_ADDEXT	147	/* Address extension		*/
#define APSR_IP_OPT_RTRALT	148	/* Router alert			*/
#define APSR_IP_OPT_SDB		149	/* Selective directed broadcast	*/
#define APSR_IP_OPT_NSAPA	150	/* NSAP addresses		*/
#define APSR_IP_OPT_DPS		151	/* Dynamic packet state		*/
#define APSR_IP_OPT_UMP		152 	/* Upstream multicast packet	*/
#define APSR_IP_OPT_FINN	205 	/* Experimental flow control	*/

