/* Flags */
#define	APSR_TCP_FIN		0x01	/* Fin */
#define	APSR_TCP_SYN		0x02	/* Syn */
#define APSR_TCP_RST		0x04	/* Reset */
#define	APSR_TCP_PSH		0x08	/* Push */
#define	APSR_TCP_ACK		0x10	/* Ack */
#define APSR_TCP_URG		0x20	/* Urgent */
#define APSR_TCP_ECE         	0x40    /* ECN Echo */
#define APSR_TCP_CWR         	0x80    /* ECN Cwnd Reduced */

/* Options */
#define APSR_TCP_OPTION_EOL		0	/* End of Option List(rfc 793)*/
#define	APSR_TCP_OPTION_NOP		1	/* No Operation (rfc 793) */
#define APSR_TCP_OPTION_MAXSEG		2	/* Maximum Segment Size	(rfc 793)*/
#define APSR_TCP_OPTION_WSCALE		3	/* Window Scale Factor(rfc 1323) */
#define APSR_TCP_OPTION_SACKOK		4	/* Selective Ack ok (rfc 2018)   */
#define APSR_TCP_OPTION_SACK		5	/* Selective Ack (rfc 2018) */
#define APSR_TCP_OPTION_ECHO		6	/* Echo (rfc 1072)	*/
#define APSR_TCP_OPTION_ECHOREPLY	7	/* Echo Reply (rfc 1072) */
#define APSR_TCP_OPTION_TIMESTAMP	8	/* Timestamp (rfc 1323) */
#define APSR_TCP_OPTION_PARTIAL_PER	9	/* Partial Order C. Permitted (rfc 1693) */
#define APSR_TCP_OPTION_PARTIAL_PRO  	10	/* Partial Order S. Profile (rfc 1693) */
#define APSR_TCP_OPTION_CC		11	/* Connection Count (rfc 1644)   */
#define APSR_TCP_OPTION_CC_NEW		12	/* C. Count new (rfc 1644) */
#define APSR_TCP_OPTION_CC_ECHO		13	/* C. Count echo (rfc 1644) */
#define APSR_TCP_OPTION_ALTER_CHK_R	14	/* Alternate Checksum request (rfc 1146) */
#define APSR_TCP_OPTION_ALTER_CHK_D	15	/* Alternate Checksum Data (rfc 1146) */

/* Don't know them, non RFC */
#if 0
#define TCP_OPTION_SKEETER	16	/* Skeeter	*/
#define TCP_OPTION_BUBBA	17	/* Bubba	*/
#endif

#define APSR_TCP_OPTION_TRAILER_CHK	18	/* Trailer Checksum Option */
#define APSR_TCP_OPTION_MD5		19 	/* MD5 signature(rfc 2385) */

/* Don't know them, non RFC */
#if 0
#define APSR_TCP_OPTION_SCPS		20	/* SCPS Capibilities	*/
#define APSR_TCP_OPTION_SEL_NEG_ACK	21      /* Selective Negativ Acknowledgement */
#define APSR_TCP_OPTION_RECORD_BOUN	22	/* Record Boundaries	*/
#define APSR_TCP_OPTION_CORRUPTION	23	/* Corruption experienced */
#define APSR_TCP_OPTION_SNAP		24	/* SNAP			*/
#define APSR_TCP_OPTION_COMPRESSION	26	/* Compression Filter	*/
#endif

#define APSR_TCP_OPT_ALTER_CHKSUM_TCP	0 /* TCP	*/
#define APSR_TCP_OPT_ALTER_CHKSUM_8BIT	1 /* 8-Bit	*/
#define APSR_TCP_OPT_ALTER_CHKSUM_16BIT	2 /* 16-Bit	*/

#define APSR_TCP_PORT_BGP	179
#define APSR_TCP_PORT_MSDP	639
#define APSR_TCP_PORT_GSMP	6068

