#include "../include/apsrlib-config.h"

int apsr_cbt (unsigned char version, unsigned char type,
              unsigned char addr_length, unsigned short sum,
	      const unsigned char *payload, int payload_size,
	      unsigned char *buf)
{
	static struct cbt_pkt_header cbt_hdr;

	if(!buf) {
	  #ifdef APSRLIB_DEBUG
	  ERROR("apsr_cbt: !buf");
	  #endif
	  return (RET_FAILURE);
	}

	cbt_hdr.version_type = ((version << 4) | 0x0f) & ((type) | 0xf0);
	cbt_hdr.addr_length  = addr_length;
	cbt_hdr.sum	     = apsr_htons(sum);

        /* Check the payload size and copy it to the buffer. */
	if(payload && payload_size) {
	  memcpy(buf + APSR_CBT, payload, payload_size);
	}

	memcpy((unsigned char *)buf, (unsigned char *)&cbt_hdr,
	       APSR_CBT);

	return(RET_SUCCESS);
}

