#include "../include/apsrlib-config.h"

/* Create a IPESP packet. */
int apsr_ipesp  (unsigned int spi, unsigned int seq_num, 
		 const unsigned char *payload,
		 int payload_size, unsigned char *buf)
{
	static struct ipesp_pkt_header ipesp_hdr;

	if(!buf) {
	  #ifdef APSRLIB_DEBUG
          ERROR("apsr_ipesp: !buf");
	  #endif
	  return(RET_FAILURE);
	}

	ipesp_hdr.spi		= apsr_htonl(spi);
	ipesp_hdr.seq_num	= apsr_htonl(seq_num);

	/* Check the payload size and copy it to the buffer. */
	if(payload && payload_size) {
	  memcpy(buf + APSR_IPESP, payload, payload_size);
	}

	memcpy((unsigned char *)buf, (unsigned char *)&ipesp_hdr,
	       APSR_IPESP);

	return(RET_SUCCESS);
}

