#include "../include/apsrlib-config.h"

/* Initialize the packet memory. */
int apsr_init_psize (size_t packet_size, unsigned char **buf) {

	/* Check the packet_size. */
	if(packet_size<=0) {
	  packet_size=APSR_MAX_PACKET_SIZE+1;
	}

	/* Allocate some memory for the buffer. */
	*buf=(unsigned char *) xmalloc(packet_size);

	/* Check if malloc succeeded. */
	if(!*buf) {
	  #ifdef APSRLIB_DEBUG
	  ERROR("apsr_init_psize malloc failed!");
	  #endif
	  return(RET_FAILURE);
	} else {
	  #ifdef APSRLIB_DEBUG
	  INFO("apsr_init_psize malloc succeeded!");
	  #endif
	  
	  memset(*buf, '\0', packet_size);
	  return(RET_SUCCESS);
	}
}
	  

/* Free the packet memory. */
int apsr_free_psize (unsigned char **buf) {
	
	/* Check the buffer. */
	if(!*buf) {
	  #ifdef APSRLIB_DEBUG
	  ERROR("apsr_free_psize free failed!");
	  #endif
	  return(RET_FAILURE);
	}

	/* Free the buffer (packet memory). */
	free(*buf);
	*buf=NULL;

	#ifdef APSRLIB_DEBUG
	INFO("apsr_free_psize free succeeded!");
	#endif

	return(RET_SUCCESS);
}

