#include "../include/apsrlib-config.h"


/* Create a PPP packet. */
int apsr_ppp (unsigned short protocol, const unsigned char *payload, 
	       int payload_size, unsigned char *buf)
{
	static struct ppp_pkt_header ppp_hdr;
	
	if(!buf) {
	  #ifdef APSRLIB_DEBUG
	  ERROR("apsr_ppp: !buf");
	  #endif
	  return(RET_FAILURE);
	}

	/* PPP protocol */
	ppp_hdr.protocol	= apsr_htons(protocol);
	
	/* Check the payload size and copy it to the buffer. */
	if(payload && payload_size) {
	  memcpy(buf + APSR_PPP, payload, payload_size);
	}

	memcpy((unsigned char *)buf, (unsigned char *)&ppp_hdr,
	       APSR_PPP);

	return(RET_SUCCESS);
}
