#include <apsrlib/apsrlib.h>

#define MODULE_VERSION		"0.01"
#define MODULE_NAME		"http"
#define MODULE_DESCRIPTION	"Example Hyper Text Transfer Protocol sniffer."
#define MODULE_IDENT_FAMILY	AF_INET
#define MODULE_IDENT_PN1	APSR_PROTO_TCP
#define MODULE_IDENT_ID1	80
#define MODULE_IDENT_ID2	80

#define MODULE_FILTER		"tcp and port 80"

struct apsr_aprecv_module_info module_info (void) {
	struct apsr_aprecv_module_info module_info;

	module_info.version	= MODULE_VERSION;
	module_info.name	= MODULE_NAME;
	module_info.desc	= MODULE_DESCRIPTION;
	module_info.bpf_filter	= MODULE_FILTER; 
        module_info.family      = MODULE_IDENT_FAMILY;
        module_info.proto1      = MODULE_IDENT_PN1;
        module_info.proto2      = 0;
        module_info.id1         = MODULE_IDENT_ID1;
        module_info.id2         = MODULE_IDENT_ID2;
        module_info.id3         = 0;
        module_info.id4         = 0;
							
	return(module_info);
}

int module_init (unsigned char *buf, int family, unsigned short protocol_number,
                 unsigned short id1, unsigned short id2)
{
	
  if(MODULE_IDENT_FAMILY == family && (MODULE_IDENT_ID1 == id1 || MODULE_IDENT_ID2 == id2)) {
	    apsr_output("- HTTP -\n");
            if(strncmp((char *)buf, "DELETE", 6) == 0)
		    apsr_output("  Method: DELETE\n");
            else if(strncmp((char *)buf, "GET", 3) == 0) 
	            apsr_output("  Method: GET\n");
            else if(strncmp((char *)buf, "HEAD", 4) == 0)
		    apsr_output("  Method: HEAD\n");
            else if(strncmp((char *)buf, "LINK", 4) == 0)
	            apsr_output("  Method: LINK\n");
            else if(strncmp((char *)buf, "OPTIONS", 7) == 0)
	            apsr_output("  Method: OPTIONS\n");
            else if(strncmp((char *)buf, "PATCH", 5) == 0)
	            apsr_output("  Method: PATCH\n");
            else if(strncmp((char *)buf, "POST", 4) == 0)
	            apsr_output("  Method: POST\n");
            else if(strncmp((char *)buf, "PUT", 3) == 0)
	            apsr_output("  Method: PUT\n");
            else if(strncmp((char *)buf, "TRACE", 5) == 0)
	            apsr_output("  Method: TRACE\n");
            else if(strncmp((char *)buf, "UNLINK", 6) == 0)
	            apsr_output("  Method: UNLINK\n");
  }

  #ifdef MODULE_DEBUG
  apsr_output("Family: %i\nPN: %i\n1: %i\n2: %i\n",
     family, protocol_number, id1, id2);
  #endif
  
  return(RET_SUCCESS);
}
