#include <apsrlib/apsrlib.h>

#define MODULE_VERSION		"0.01"
#define MODULE_NAME		"iua"
#define MODULE_DESCRIPTION	"Example ISDN Q.921-User Adaptation sniffer."
#define MODULE_IDENT_FAMILY	AF_INET
#define MODULE_IDENT_PN1	APSR_PROTO_TCP
#define MODULE_IDENT_ID1	9900
#define MODULE_IDENT_ID2	9900

#define MODULE_FILTER		"tcp and port 9900"

struct mod_iua_header {
	unsigned char version;
	unsigned char reserved;
	unsigned char message_class;
	unsigned char message_type;
	unsigned int message_length;
};

struct apsr_aprecv_module_info module_info (void) {
	struct apsr_aprecv_module_info module_info;

	module_info.version	= MODULE_VERSION;
	module_info.name	= MODULE_NAME;
	module_info.desc	= MODULE_DESCRIPTION;
	module_info.bpf_filter	= MODULE_FILTER; 
        module_info.family      = MODULE_IDENT_FAMILY;
        module_info.proto1      = MODULE_IDENT_PN1;
        module_info.proto2      = 0;
        module_info.id1         = MODULE_IDENT_ID1;
        module_info.id2         = MODULE_IDENT_ID2;
        module_info.id3         = 0;
        module_info.id4         = 0;
							
	return(module_info);
}

int module_init (unsigned char *buf, int family, unsigned short protocol_number,
                 unsigned short id1, unsigned short id2)
{
  struct mod_iua_header *iua_header;
	
  if(MODULE_IDENT_FAMILY == family && (MODULE_IDENT_ID1 == id1 || MODULE_IDENT_ID2 == id2)) {
	    iua_header = (struct mod_iua_header *)buf;
	    apsr_output("- IUA Header -\n");
	    apsr_output("  Version: %u, Reserved: %u\n", 
			    iua_header->version,
			    iua_header->reserved);
	    apsr_output("  Message Class: %u, Message Type: %u\n",
			    iua_header->message_class,
			    iua_header->message_length);
	    apsr_output("  Message Length: %u\n",
			    apsr_ntohl(iua_header->message_length));
  }

  #ifdef MODULE_DEBUG
  apsr_output("Family: %i\nPN: %i\n1: %i\n2: %i\n",
     family, protocol_number, id1, id2);
  #endif
  
  return(RET_SUCCESS);
}
